From 372918c54c9191828de3314b20fda73251bbcc0f Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 710/1001] Adapt the backend workers to the new CachedFunction


---

diff --git a/hubs/backend/triage.py b/hubs/backend/triage.py
index c1bf1da..7320460 100755
--- a/hubs/backend/triage.py
+++ b/hubs/backend/triage.py
@@ -58,25 +58,21 @@ def triage(session, outbound, msg):
     log.debug("Randomizing list of all widgets.")
     random.shuffle(widgets)
 
+    def is_widget_update(msg, widget):
+        """Always rebuild the cache when the widget config is updated."""
+        return msg['topic'].endswith('hubs.widget.update') \
+            and msg['msg']['widget']['id'] == widget.idx
+
     log.debug("Checking should_invalidate for all widgets.")
     for widget in widgets:
-
-        check = widget.module.should_invalidate
-
-        # Do some pre-flight checks before calling should_invalidate
-        if hasattr(check, 'hints'):
-            if check.hints['topics']:
-                if topic not in check.hints['topics']:
-                    continue
-            if check.hints['categories']:
-                if category not in check.hints['categories']:
-                    continue
-
-        if check(msg, session, widget):
-            yield retask.task.Task(json.dumps({
-                'idx': widget.idx,
-                'msg_id': msg['msg_id'],
-            }))
+        for fn_name, fn_class in widget.module.get_cached_functions().items():
+            if is_widget_update(msg, widget) or \
+                    fn_class(widget).should_invalidate(msg):
+                yield retask.task.Task(json.dumps({
+                    'idx': widget.idx,
+                    'fn_name': fn_name,
+                    'msg_id': msg['msg_id'],
+                }))
 
 
 def main(args):
diff --git a/hubs/backend/worker.py b/hubs/backend/worker.py
index b4af706..e8e63e3 100755
--- a/hubs/backend/worker.py
+++ b/hubs/backend/worker.py
@@ -44,24 +44,22 @@ import logging.config
 log = logging.getLogger('hubs.backend.worker')
 
 
-def work(session, widget_idx):
+def work(widget_idx, fn_name):
     # Get a real widget, because we update last_refreshed on it.
     widget = hubs.models.Widget.by_idx(widget_idx)
-    log.info("! Invalidating cache for %r" % widget)
+    fn_class = widget.module.get_cached_functions()[fn_name]
+    log.info("! Rebuilding cache for %r:%r" % (widget, cached_fn))
     # Invalidate the cache...
-    hubs.widgets.base.invalidate_cache(widget, **widget.config)
-    # Rebuild it.
-    log.info("! Rebuilding cache for %r" % widget)
-    widget.module.data(session, widget, **widget.config)
+    fn_class(widget).rebuild()
     # TODO -- fire off an EventSource notice that we updated stuff
 
 
-def handle(idx):
+def handle(idx, fn_name):
     session = hubs.models.init(config['hubs.sqlalchemy.uri'])
 
     try:
         with hubs.app.app.app_context():  # so url_for works
-            work(session, idx)
+            work(idx, fn_name)
         session.commit()  # transaction is committed here
     except:
         session.rollback()  # rolls back the transaction
@@ -91,7 +89,7 @@ def main(args):
             log.info("Working on %r.  (backlog is %r)" % (task, queue.length))
             item = json.loads(task.data)
             idx = item['idx']  # A widget ID
-            handle(idx)
+            handle(item['idx'], item['fn_name'])
             log.debug("  Done.")
     except KeyboardInterrupt:
         pass

